/* Init.c generated by valac 0.56.14, the Vala compiler
 * generated from Init.vala, do not modify */

/*
 * Copyright 2021 elementary, Inc. (https://elementary.io)
 * SPDX-License-Identifier: LGPL-3.0-or-later
 */

#include <glib.h>
#include <gtk/gtk.h>
#include "granite-7.h"
#include <glib-object.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

#define GRANITE_GETTEXT_PACKAGE "granite-7"
#define GRANITE_LOCALEDIR "/usr/share/locale"

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

VALA_EXTERN gboolean granite_initialized;
gboolean granite_initialized = FALSE;
VALA_EXTERN GtkCssProvider* granite_base_provider;
GtkCssProvider* granite_base_provider = NULL;
VALA_EXTERN GtkCssProvider* granite_app_provider;
GtkCssProvider* granite_app_provider = NULL;

 G_GNUC_INTERNAL void granite_register_display (GdkDisplay* display);
static void _granite_register_display_gdk_display_manager_display_opened (GdkDisplayManager* _sender,
                                                                   GdkDisplay* display,
                                                                   gpointer self);
 G_GNUC_INTERNAL GtkCssProvider* granite_init_provider_from_file (GFile* file);

static void
_granite_register_display_gdk_display_manager_display_opened (GdkDisplayManager* _sender,
                                                              GdkDisplay* display,
                                                              gpointer self)
{
	granite_register_display (display);
}

void
granite_init (void)
{
	GdkDisplayManager* display_manager = NULL;
	GdkDisplayManager* _tmp0_;
	GdkDisplayManager* _tmp1_;
	GdkDisplayManager* _tmp2_;
	GSList* _tmp3_;
	if (granite_initialized) {
		return;
	}
	g_type_ensure (GRANITE_TYPE_SETTINGS);
	_tmp0_ = gdk_display_manager_get ();
	display_manager = _tmp0_;
	_tmp1_ = display_manager;
	g_signal_connect (_tmp1_, "display-opened", (GCallback) _granite_register_display_gdk_display_manager_display_opened, NULL);
	_tmp2_ = display_manager;
	_tmp3_ = gdk_display_manager_list_displays (_tmp2_);
	{
		GSList* display_collection = NULL;
		GSList* display_it = NULL;
		display_collection = _tmp3_;
		for (display_it = display_collection; display_it != NULL; display_it = display_it->next) {
			GdkDisplay* display = NULL;
			display = (GdkDisplay*) display_it->data;
			{
				GdkDisplay* _tmp4_;
				_tmp4_ = display;
				granite_register_display (_tmp4_);
			}
		}
		(display_collection == NULL) ? NULL : (display_collection = (g_slist_free (display_collection), NULL));
	}
	bindtextdomain (GRANITE_GETTEXT_PACKAGE, GRANITE_LOCALEDIR);
	bind_textdomain_codeset (GRANITE_GETTEXT_PACKAGE, "UTF-8");
	granite_initialized = TRUE;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

 G_GNUC_INTERNAL void
granite_register_display (GdkDisplay* display)
{
	GtkCssProvider* _tmp0_;
	GtkCssProvider* _tmp3_;
	GtkCssProvider* _tmp17_;
	GtkCssProvider* _tmp18_;
	GtkIconTheme* icon_theme = NULL;
	GtkIconTheme* _tmp20_;
	GtkIconTheme* _tmp21_;
	g_return_if_fail (display != NULL);
	_tmp0_ = granite_base_provider;
	if (_tmp0_ == NULL) {
		GtkCssProvider* _tmp1_;
		GtkCssProvider* _tmp2_;
		_tmp1_ = gtk_css_provider_new ();
		_g_object_unref0 (granite_base_provider);
		granite_base_provider = _tmp1_;
		_tmp2_ = granite_base_provider;
		gtk_css_provider_load_from_resource (_tmp2_, "/io/elementary/granite/Granite.css");
	}
	_tmp3_ = granite_app_provider;
	if (_tmp3_ == NULL) {
		gchar* base_path = NULL;
		GApplication* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		const gchar* _tmp8_;
		_tmp4_ = g_application_get_default ();
		_tmp5_ = g_application_get_resource_base_path (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp7_ = g_strdup (_tmp6_);
		base_path = _tmp7_;
		_tmp8_ = base_path;
		if (_tmp8_ != NULL) {
			gchar* base_uri = NULL;
			const gchar* _tmp9_;
			gchar* _tmp10_;
			GFile* base_file = NULL;
			const gchar* _tmp11_;
			GFile* _tmp12_;
			GFile* _tmp13_;
			GFile* _tmp14_;
			GFile* _tmp15_;
			GtkCssProvider* _tmp16_;
			_tmp9_ = base_path;
			_tmp10_ = g_strconcat ("resource://", _tmp9_, NULL);
			base_uri = _tmp10_;
			_tmp11_ = base_uri;
			_tmp12_ = g_file_new_for_uri (_tmp11_);
			base_file = _tmp12_;
			_tmp13_ = base_file;
			_tmp14_ = g_file_get_child (_tmp13_, "Application.css");
			_tmp15_ = _tmp14_;
			_tmp16_ = granite_init_provider_from_file (_tmp15_);
			_g_object_unref0 (granite_app_provider);
			granite_app_provider = _tmp16_;
			_g_object_unref0 (_tmp15_);
			_g_object_unref0 (base_file);
			_g_free0 (base_uri);
		}
		_g_free0 (base_path);
	}
	_tmp17_ = granite_base_provider;
	gtk_style_context_add_provider_for_display (display, (GtkStyleProvider*) _tmp17_, (guint) GTK_STYLE_PROVIDER_PRIORITY_THEME);
	_tmp18_ = granite_app_provider;
	if (_tmp18_ != NULL) {
		GtkCssProvider* _tmp19_;
		_tmp19_ = granite_app_provider;
		gtk_style_context_add_provider_for_display (display, (GtkStyleProvider*) _tmp19_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
	}
	_tmp20_ = gtk_icon_theme_get_for_display (display);
	_tmp21_ = _g_object_ref0 (_tmp20_);
	icon_theme = _tmp21_;
	gtk_icon_theme_add_resource_path (icon_theme, "/io/elementary/granite");
	_g_object_unref0 (icon_theme);
}

 G_GNUC_INTERNAL GtkCssProvider*
granite_init_provider_from_file (GFile* file)
{
	GtkCssProvider* result;
	g_return_val_if_fail (file != NULL, NULL);
	if (g_file_query_exists (file, NULL)) {
		GtkCssProvider* provider = NULL;
		GtkCssProvider* _tmp0_;
		GtkCssProvider* _tmp1_;
		_tmp0_ = gtk_css_provider_new ();
		provider = _tmp0_;
		_tmp1_ = provider;
		gtk_css_provider_load_from_file (_tmp1_, file);
		result = provider;
		return result;
	}
	result = NULL;
	return result;
}

